/*
 * Copyright (C) 2011 ~ 2018 Deepin Technology Co., Ltd.
 *
 * Author:     sbw <sbw@sbw.so>
 *
 * Maintainer: sbw <sbw@sbw.so>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SYSTEMTRAYSCONTROLLER_H
#define SYSTEMTRAYSCONTROLLER_H

#include "pluginproxyinterface.h"
#include "abstractpluginscontroller.h"
#include "abstractpluginscontroller.h"

#include <QPluginLoader>
#include <QList>
#include <QMap>
#include <QDBusConnectionInterface>

class PluginsItemInterface;
class SystemPluginItem;

class SystemPluginController : public AbstractPluginsController
{
    Q_OBJECT

public:
    explicit SystemPluginController(QObject *parent = nullptr);

    // implements PluginProxyInterface
    void pluginItemAdded(PluginsItemInterface * const itemInter, const QString &itemKey) override;
    void pluginItemUpdate(PluginsItemInterface * const itemInter, const QString &itemKey) override;
    void pluginItemRemoved(PluginsItemInterface * const itemInter, const QString &itemKey) override;
    void requestPluginWindowAutoHide(PluginsItemInterface * const itemInter, const QString &itemKey, const bool autoHide) override;
    void requestRefreshPluginWindowVisible(PluginsItemInterface * const itemInter, const QString &itemKey) override;
    void requestSetPluginAppletVisible(PluginsItemInterface * const itemInter, const QString &itemKey, const bool visible) override;

    int systemTrayItemSortKey(const QString &itemKey);
    void setSystemTrayItemSortKey(const QString &itemKey, const int order);

    const QVariant getValueSystemTrayItem(const QString &itemKey, const QString &key, const QVariant& fallback = QVariant());
    void saveValueSystemTrayItem(const QString &itemKey, const QString &key, const QVariant &value);

    void startLoader();

signals:
    void pluginItemAdded(const QString &itemKey, SystemPluginItem *pluginItem);
    void pluginItemRemoved(const QString &itemKey, SystemPluginItem *pluginItem);
    void pluginItemUpdated(const QString &itemKey, SystemPluginItem *pluginItem);
};

#endif // SYSTEMTRAYSCONTROLLER_H
